local Heatsink = LibStub("AceAddon-3.0"):GetAddon("Heatsink")
Heatsink.tooltip = CreateFrame("GameTooltip")
Heatsink.tooltip:SetOwner(WorldFrame, "ANCHOR_NONE")

local lcache, rcache = {}, {}
for i=1,30 do
	lcache[i], rcache[i] = Heatsink.tooltip:CreateFontString(), Heatsink.tooltip:CreateFontString()
	lcache[i]:SetFontObject(GameFontNormal); rcache[i]:SetFontObject(GameFontNormal)
	Heatsink.tooltip:AddFontStrings(lcache[i], rcache[i])
end


-- GetText cache tables, provide fast access to the tooltip's text
Heatsink.tooltip.R = setmetatable({}, {
	__index = function(t, key)
		if Heatsink.tooltip:NumLines() >= key and rcache[key] then
			local v = rcache[key]:GetText()
			t[key] = v
			return v
		end
		return nil
	end,
})


local orig = Heatsink.tooltip.SetSpell
Heatsink.tooltip.SetSpell = function(self, ...)
	self:ClearLines() -- Ensures tooltip's NumLines is reset
	for i in pairs(self.R) do self.R[i] = nil end -- Flush the metatable cache
	if not self:IsOwned(WorldFrame) then self:SetOwner(WorldFrame, "ANCHOR_NONE") end
	return orig(self, ...)
end
